package de.tud.kom.p2psim.impl.topology.movement.vehicular.information;

import java.awt.geom.Point2D;
import java.util.HashMap;
import java.util.Map;

import de.tud.kom.p2psim.impl.topology.movement.vehicular.sumo.simulation.controller.SimulationSetupInformationProvider;

public class LocationUtils {
    private static boolean _saveID = false;
    private static Map<String, Long> _ids = new HashMap<>();
    private static long _currentID = 0;

    public static Position createPosition(Point2D pPosition, double pHeading) {
        Position position = SimulationSetupInformationProvider.getOnlyInstance().getUpperLeft();
        double lat = position.getY() + pPosition.getY() / 10000000 * 90;
        double lon = position.getX() + pPosition.getX()
        / (20000000 * Math.cos(position.getY() / 180 * Math.PI)) * 180;

        return new Position(lon, lat, position.getAlt(), pHeading);
    }

    public static long calculateID(String pID) {
        long numericalID = -1;
        if (!_saveID) {
            try {
                String[] split = pID.split("_");
                for (int i = 0; i < split.length; i++) {
                    numericalID *= 100000;
                    numericalID += Integer.valueOf(split[i]);
                }
            } catch (NumberFormatException e) {
                _saveID = true;
            }
        }
        if (_saveID) {
            synchronized (_ids) {
                if (!_ids.containsKey(pID)) {
                    _ids.put(pID, _currentID++);
                }
                numericalID = _ids.get(pID);
            }
        }
        return numericalID;
    }

    public static double calculateDistance(Position start, Position end) {
        return Math.sqrt(Math.pow(end.getY() - start.getY(), 2) + Math.pow(end.getX() - start.getX(), 2)) / 1000.0;
    }
}
